#pragma once

class Dimmer
{
  public:
    void Init(int relay, int led);
    void Configure();
    void Start();
    void Loop();
    
    void TurnLedOff(bool off);
    bool TurnClientOff(bool off);
  private:
    void Blink();
    bool ShouldTurnOff(int ldr, bool immediate);
    void ResetRange();
    void UpdateRange(int ldr);

    int m_relay = -1;
    int m_led = -1;
    bool m_bClientOff = false;
    bool m_bManualMode = false;
    bool m_bManualOff = false;
    int  m_OnMax = 0;
    int  m_OffMin = 1024;
    unsigned long m_LastCheckMS = 0;
    unsigned long m_LastClientStateChangeMS = 0;

    static const int kAmbientThreshold = 256;
    static const int kAmbientGreyArea = 16;
    static const unsigned long kGreyAreaTimoutMS = 60000UL;
    // Client is OFF when relay is OFF:
    static const int kRelayClientOff = LOW;
    // check 10x per second
    static const unsigned long kCheckAmbientIntervalMS = 100UL;
};

extern Dimmer dimmer;
