#include <Arduino.h>
#include "LDR.h"

LDR ldr;

void LDR::Init(int modePin, int readPin)
{
  m_pin = readPin;
  pinMode(modePin, INPUT);  
  m_index = 0;
  memset(m_readings, 0, sizeof(m_readings));
}

int LDR::ReadImmediate()
{
  // just return the current reading
  return analogRead(m_pin);
}

int LDR::ReadAverage()
{
  // return the rolling average of the last <kNumReadings> readings
  m_index = (m_index + 1) % kNumReadings;
  m_readings[m_index] = ReadImmediate();
  long int sum = 0;
  for (int i = 0; i < kNumReadings; i++)
    sum += m_readings[i];
  long int avg = sum/kNumReadings;
  return avg;
}
