#include <Arduino.h>
#include "Pins.h"
#include "BTN.h"
#include "LDR.h"
#include "Dimmer.h"
// LDRelay
// A module taking USB in and directing it via a relay to a client device on USB out.
// The relay is controlled by an LDR, when the environment goes dim, the client is turned off.
// When it brightens, the client is turned back on.
// Pressing the button flips the client on/off state and sets a manual over-ride flag.
// The manuaul over-ride is cleared when the ambient matches the manual state.
//
// Configuration of the ambient threshold is via a pot.  
// Holding the button at power on goes into a mode with immediate feedback (via a LED)
// of the client on/off status.
//
// Mark Wilson Sept 2019

// Notes:
// When ON relay draws 140mA
// FlipClock draws 160mA
// Actual max=280mA

void setup() 
{
#ifndef ARDUINO_AVR_TRINKET3
  Serial.begin(38400);
#endif  
  
  btn.Init(PIN_BTN);
  ldr.Init(PIN_LDR_MODE, PIN_LDR_READ);
  dimmer.Init(PIN_RELAY, PIN_LED);

  if (btn.IsDown())
    dimmer.Configure();
  dimmer.Start();
}

void loop() 
{
  dimmer.Loop();
}
